<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xi="http://www.w3.org/2001/XInclude"
  xmlns:xc="urn:xhtml-compiler"
  xmlns:news="urn:xhtml-compiler:News"
  xml:lang="en">
<head>
<title>csrf-magic: Wizard CSRF Protection for PHP</title>
<xi:include href="common-meta.xml" xpointer="xpointer(/*/node())" />
<link rel="alternate" type="application/rss+xml" title="News - csrf-magic" href="news.rss" />
<meta name="description"
  content="Drop-in PHP library that automagically adds CSRF protection to an application." />
<meta name="keywords"
  content="library, security, open source, csrf, cross-site request forgery, protection" />
</head>
<body>
<h1 id="title" title="Yah, I know the vignette kinda sucks. Any graphic designers want to step up?">csrf-magic</h1>
<div id="body">
<div id="content">
<p>
  Securing your application against Cross-Site Request Forgery has never been
  easier.  Why rewrite every form on your website when a program can do it for
  you?  Simply drop this at the top of every PHP file:
</p>
<pre><code>require_once '/path/to/csrf-magic.php';
</code></pre>
<p>
  ...and let the magic take care of the rest.
  <a href="releases/csrf-magic-1.0.4.tar.gz">Download it now</a>!
  Or try out <a href="dev/test.php">the demo</a>.
</p>

<h2>News</h2>
<div class="news" news:source="news" news:limit="1" news:header="h3" />

<h2>What is CSRF?</h2>
<p>
Cross-Site Request Forgery (CSRF) is a relatively new attack vector on
websites today.  It involves an attacker tricking a browser into performing
an action on another website.  Imagine this scenario: Bob,
the human resources manager
for a large and important company, has the ability to hire and fire with
a click of a button. Specifically, a web form button.  Mallory, as a practical
joke, decides to stage a CSRF attack against Bob.  She baits Bob with
a webpage that automatically submits a form to the hire'n'fire website.
The next morning, every employee finds a pink slip in his inbox.
</p>

<h2>Why csrf-magic?</h2>
<p>
The current standard for preventing CSRF is creating a nonce that every user
submits with any form he/she submits.  This is reasonably effective, but
incredibly tedious work; if you are hand-writing your forms or have multiple
avenues for POST data to enter your application, adding CSRF protection may not
seem worth the trouble.
</p>

<p>
This is where csrf-magic comes into play.  csrf-magic uses PHP's output
buffering capabilities to dynamically rewrite forms and scripts in your document.
It will also intercept POST requests and check their token (various algorithms
are used; some generate nonces, some generate user-specific tokens).  This means,
for a traditional website with forms, you can drop csrf-magic into your application
and forget about it!
</p>

<h2>External links</h2>
<ul>
  <li><a href="http://repo.or.cz/w/csrf-magic.git">repo.or.cz</a>, the location
    of our Git source code repository. Bleeding edge development builds can be
    found here. They are also
    <a href="http://git.htmlpurifier.org/csrf-magic.git">mirrored here</a>.</li>
  <li><a href="http://code.google.com/p/csrfx/">CSRFx</a>, a similar
    library with similar goals. They haven't made a release yet, but the code
    in the repository is working.
  </li>
  <li><a href="http://code.djangoproject.com/browser/django/trunk/django/contrib/csrf/middleware.py">Django CSRF Middleware</a>,
    an extension for the Python web framework that has the same basic ideas
    as ours for rewriting output.
  </li>
  <li><a href="http://directwebremoting.org/">Direct Web Remoting</a>, a JavaScript/Java
    framework that features
    <a href="http://directwebremoting.org/blog/joe/2007/01/01/csrf_attacks_or_how_to_avoid_exposing_your_gmail_contacts.html">AJAX
    rewriting for CSRF protection</a>.
  </li>
  <li><a href="http://htmlpurifier.org/">HTML Purifier</a>, a standards-compliant
    XSS filter. If your site is vulnerable to XSS, the best CSRF protection in the
    world won't save you.
  </li>
</ul>

</div>
</div>

</body>
</html>
